VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CCache"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Copyright 2005
'dzzie@yahoo.com
'http://sandsprite.com

'this class handles UI display
'right nowit just refreshs everything every step..but eventually i want
'it to walk through a cache of instructions highlighting the current line
'and displaying lines with breakpoints etc..

Public Instructions As Collection

Public MinVA As Long
Public MaxVA As Long
Public Display As PictureBox
Public RegBox As PictureBox
Public Stack As PictureBox
Public Memory As PictureBox

Public ActiveVA As Long

Sub StepOver()
    Dim ci As CInstruction
    Set ci = Instructions(1)
    If InStr(ci.command, "CALL") < 0 Then 'nothing to step over!
        tm.SetSingleStep: dbg.Run
    Else
        Set ci = Instructions(2)
        If bpm.AddBreakPoint(CLng("&h" & ci.offset)) Then
            dbg.Run
        Else
            Additem "Error setting breakpoint after call. addr: " & ci.offset
        End If
    End If
End Sub


Sub Refresh()
    LoadAddress dbg.LastEventAddress
    dumpRegisters
    RefreshStack
End Sub

Sub DrawDisasm()
       
    Dim ci As CInstruction
    Dim lineNum As Long
    
    Display.Cls
    
    For Each ci In Instructions
        Display.Print Pad(ci.offset, 9) & Pad(ci.dump, 24) & Pad(ci.command) & sym.GetSymbolForAsm(ci.command)
    Next

End Sub

Sub LoadAddress(base As Long)

    Dim b() As Byte
    Dim Length As Long
    
    Length = 200
       
    'better to read activememory in 20 byte chunks from
    'incremental va instead of one long block which can
    'run out!
    b = ReadBuf(base, Length)
        
    Dim va As Long
    Dim tmp() As Byte
    Dim pointer As Long
    Dim i As Long
    
    va = base
    Dim d As CInstruction
    
    Set Instructions = New Collection
    
    pointer = 0
     
    Do While pointer < UBound(b) + 1
    
        ReDim tmp(UBound(b) - pointer + 1)
        CopyMemory tmp(0), b(pointer), UBound(tmp)
        
        'breakpoint only support being at first byte of inst!
        If bpm.BpExists(va) Then
            If bpm.isOneShot(va) Then 'only support oneshot atm.
                tmp(0) = bpm.GetOrigByte(va)
                WriteByte va, tmp(0)
                bpm.RemoveBreakPoint va  'was oneshot
            Else
                'lets see..we have to remove it from mem and restore for disasm
                'then we have to set some flag to that after run again it is restored
            End If
        End If
        
        Set d = disasm.DisasmBytes(tmp, va)
        Instructions.Add d
        
        va = va + d.instLen
        pointer = pointer + d.instLen
        i = i + 1
        
        If i > 30 Then Exit Do 'only need enough to fill disasm window
        
    Loop
    
    'these are for the day we highlight a line per disasm
    'without having to re disasm the whole display everytime
    MinVA = base
    MaxVA = va
    
    DrawDisasm
    RefreshStack
    
End Sub

Sub dumpRegisters()

   Dim sctx As CONTEXT
   Dim vals() As String, i As Long
   Dim flags() As String
   
   RegBox.Cls
   sctx = GetContext(tm.ActiveThreadID)
   
  
   push vals(), "EAX " & Hex(sctx.Eax) & " " & sym.GetSymbol(sctx.Eax)
   push vals(), "EBX " & Hex(sctx.Ebx) & " " & sym.GetSymbol(sctx.Ebx)
   push vals(), "ECX " & Hex(sctx.Ecx) & " " & sym.GetSymbol(sctx.Ecx)
   push vals(), "EDX " & Hex(sctx.Edx) & " " & sym.GetSymbol(sctx.Edx)
   push vals(), "ESI " & Hex(sctx.Esi) & " " & sym.GetSymbol(sctx.Esi)
   push vals(), "EDI " & Hex(sctx.Edi) & " " & sym.GetSymbol(sctx.Edi)
   push vals(), "ESP " & Hex(sctx.Esp) & " " & sym.GetSymbol(sctx.Esp)
   push vals(), "EBP " & Hex(sctx.Ebp) & " " & sym.GetSymbol(sctx.Ebp)
   push vals(), ""
   push vals(), "EIP " & Hex(sctx.Eip) & " " & sym.GetSymbol(sctx.Eip)
    
   For i = 0 To UBound(vals)
        RegBox.Print vals(i)
   Next
 
    RegBox.Print ""
    
    push flags(), "C  " & (sctx.EFlags And 1&)
    push flags(), "P  " & ((sctx.EFlags And 4&) / 4&)
    push flags(), "A  " & ((sctx.EFlags And 16&) / 16&)
    push flags(), "Z  " & ((sctx.EFlags And 64&) / 64&)
    push flags(), "S  " & ((sctx.EFlags And 128&) / 128&)
    push flags(), "T  " & ((sctx.EFlags And 256&) / 256&)
    'push flags(), "int     " & ((sctx.EFlags And 512&) / 512&)
    'push flags(), "Dir     " & ((sctx.EFlags And 1024&) / 1024&)
    push flags(), "O  " & ((sctx.EFlags And 2048&) / 2048&)
    'push flags(), "iopl    " & ((sctx.EFlags And 4096&) / 4096&)
    'push flags(), "nested  " & ((sctx.EFlags And 8192&) / 8192&)
    'push flags(), "Resume  " & ((sctx.EFlags And 32768) / 32768)
    'push flags(), "Virt    " & ((sctx.EFlags And 65536) / 65536)
    'push flags(), "AlngChk " & ((sctx.EFlags And 131072) / 131072)

   For i = 0 To UBound(flags)
        RegBox.Print flags(i)
   Next
 


End Sub

Sub ModifyRegister(reg As Registers, valu As Long)
    
   Dim sctx As CONTEXT
   sctx = GetContext(tm.ActiveThreadID)
   
   With sctx
        Select Case reg
             Case Edi: .Edi = valu
             Case Esi: .Esi = valu
             Case Ebx: .Ebx = valu
             Case Edx: .Edx = valu
             Case Ecx: .Ecx = valu
             Case Eax: .Eax = valu
             Case Ebp: .Ebp = valu
             Case Eip: .Eip = valu
             Case Esp: .Esp = valu
        End Select
    End With
   
  SetContext tm.ActiveThreadID, sctx
  dumpRegisters

  If reg = Eip Then LoadAddress valu


End Sub

Function ReadRegister(reg As Registers) As Long
    
   Dim sctx As CONTEXT
   sctx = GetContext(tm.ActiveThreadID)
   
   With sctx
        Select Case reg
             Case Edi: ReadRegister = .Edi
             Case Esi: ReadRegister = .Esi
             Case Ebx: ReadRegister = .Ebx
             Case Edx:  ReadRegister = .Edx
             Case Ecx: ReadRegister = .Ecx
             Case Eax: ReadRegister = .Eax
             Case Ebp: ReadRegister = .Ebp
             Case Eip: ReadRegister = .Eip
             Case Esp: ReadRegister = .Esp
        End Select
    End With

End Function

Sub RefreshStack()
    
    Dim sctx As CONTEXT
    sctx = GetContext(tm.ActiveThreadID)
    
    Dim top As Long
    Dim bottom As Long
    Dim i As Long
    
    bottom = sctx.Esp
    top = sctx.Ebp
        
    'we cant scroll yet so..
    
    If (top - bottom) > 100 Then bottom = top - 100
    
    Dim b() As Byte
    b = ReadBuf(bottom, (top - bottom))
    
    Stack.Cls
    
    Dim val As Long
    Dim s As String
    
    On Error Resume Next
    For i = 0 To UBound(b) Step 4
        CopyMemory val, b(i), 4
        s = Hex(val)
        While Len(s) < 8: s = "0" & s: Wend
        Stack.Print Hex((bottom + i)) & " " & s
    Next
    
    
  
End Sub

Sub DumpMemory(va As Long)
    Dim b() As Byte
    b() = ReadBuf(va, 160)
    
    Memory.Cls
    Memory.Print hexdump(va, b)
    
End Sub


