VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CDebugger"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Copyright 2005
'dzzie@yahoo.com
'http://sandsprite.com

Dim WithEvents subclass As clsSubClass
Attribute subclass.VB_VarHelpID = -1

Private Declare Function LaunchDebugedProcess Lib "vb_dbg.dll" (ByVal filename As String) As Long
Private Declare Function AttachDebugger Lib "vb_dbg.dll" (ByVal pid As Long) As Long
Private Declare Sub Continue Lib "vb_dbg.dll" ()
Private Declare Sub StopDebugger Lib "vb_dbg.dll" ()
Private Declare Sub SetTargetHwnd Lib "vb_dbg.dll" (ByVal hwnd As Long)


Dim Loaded As Boolean
Public LastEventAddress As Long

Property Get isDebugging() As Boolean
    isDebugging = Loaded
End Property

Private Sub subclass_MessageReceived(hwnd As Long, wMsg As Long, wParam As Long, lParam As Long, Cancel As Boolean)
    Dim CopyData As COPYDATASTRUCT
    Dim dbgEvent As DEBUG_EVENT
    
    If wMsg = WM_COPYDATA Then
        CopyMemory CopyData, ByVal lParam, Len(CopyData)
        If CopyData.dwFlag = 3 Then
            CopyMemory dbgEvent, ByVal CopyData.lpData, CopyData.cbSize
            DebugHandler dbgEvent
        End If
    End If
    
End Sub



Private Sub DebugHandler(dbgEvent As DEBUG_EVENT)
    
    On Error Resume Next
    
    Dim dll As LOAD_DLL_DEBUG_INFO
    Dim thread As CREATE_THREAD_DEBUG_INFO
    Dim except As EXCEPTION_DEBUG_INFO
    
    Dim lngVal As Long
    Dim info As String
    Dim noContinue As Boolean
    
    tm.ActiveThreadID = dbgEvent.dwThreadId
    
    Select Case dbgEvent.dwDebugEventCode
        
              
        Case LOAD_DLL_DEBUG_EVENT
               CopyMemory dll, dbgEvent.Data(0), Len(dll)
               mm.AddModule dll.lpBaseOfDll, dll.hFile
               info = "Base: 0x" & Hex(dll.lpBaseOfDll) & " "
               info = info & mm.ModuleAtBase(dll.lpBaseOfDll)
               
        Case CREATE_THREAD_DEBUG_EVENT
                CopyMemory thread, dbgEvent.Data(0), Len(thread)
                tm.AddThread dbgEvent.dwThreadId, thread.hThread
                info = "id: " & thread.hThread & " start:" & thread.lpStartAddress
                
        Case CREATE_PROCESS_DEBUG_EVENT
                CopyMemory ProcessInfo, dbgEvent.Data(0), Len(ProcessInfo)
                tm.AddThread dbgEvent.dwThreadId, ProcessInfo.hThread
                info = "hThread: " & ProcessInfo.hThread & " pid: " & ProcessInfo.hProcess & " start:" & ProcessInfo.lpStartAddress
        
        Case UNLOAD_DLL_DEBUG_EVENT
                CopyMemory lngVal, dbgEvent.Data(0), 4
                info = "Base 0x" & Hex(lngVal) & " " & mm.ModuleAtBase(lngVal)
                mm.RemoveModule lngVal
        
        Case EXIT_THREAD_DEBUG_EVENT
                CopyMemory lngVal, dbgEvent.Data(0), 4
                tm.RemoveThread dbgEvent.dwThreadId
                info = "ExitCode " & lngVal
        
        Case EXIT_PROCESS_DEBUG_EVENT
                CopyMemory lngVal, dbgEvent.Data(0), 4
                info = "ExitCode " & lngVal
                dbg.StopDbg
                
        Case EXCEPTION_DEBUG_EVENT
                CopyMemory except, dbgEvent.Data(0), Len(except)
                HandleException except, dbgEvent
                info = "Addr: " & Hex(except.ExceptionRecord.ExceptionAddress)
                noContinue = True
                
              
                
    End Select
       
    If dbgEvent.dwDebugEventCode = EXCEPTION_DEBUG_EVENT Then
        info = info & " " & GetEvent(except.ExceptionRecord.ExceptionCode)
    End If
    
    Additem GetEvent(dbgEvent.dwDebugEventCode) & "  " & info
 
    
    
    If Not noContinue Then dbg.Run
    
End Sub


Private Sub HandleException(except As EXCEPTION_DEBUG_INFO, dbgEvent As DEBUG_EVENT)
    Dim tmp As String
    Dim isOk As Boolean
    
    Select Case except.ExceptionRecord.ExceptionCode
        Case EXCEPTION_ACCESS_VIOLATION
        Case EXCEPTION_ILLEGAL_INSTRUCTION
        Case EXCEPTION_INT_OVERFLOW
        Case EXCEPTION_DATATYPE_MISALIGNMENT
        Case EXCEPTION_SINGLE_STEP
        
        Case EXCEPTION_BREAKPOINT
                If bpm.BpExists(except.ExceptionRecord.ExceptionAddress) Then
                    cache.ModifyRegister Eip, cache.ReadRegister(Eip) - 1
                Else
                    If Not Loaded Then
                        'this is first system bpx in loader, lets jump to app EP
                        cache.DumpMemory ProcessInfo.lpStartAddress
                        bpm.AddBreakPoint ProcessInfo.lpStartAddress
                        Loaded = True
                        Run
                    End If
                End If
                DoEvents
                
        Case Else
    End Select
    
    LastEventAddress = except.ExceptionRecord.ExceptionAddress
    cache.LoadAddress except.ExceptionRecord.ExceptionAddress
    cache.dumpRegisters
    
End Sub

Function Initilize(hwnd As Long)
    Set subclass = New clsSubClass
    subclass.AttachMessage hwnd, WM_COPYDATA
    SetTargetHwnd hwnd
End Function

Function LaunchProcess(ByVal path As String) As Boolean
        Loaded = False
        LaunchProcess = CBool(LaunchDebugedProcess(path))
End Function

Function Attach(pid As Long) As Boolean
    Loaded = False
    Attach = CBool(AttachDebugger(pid))
End Function

Sub PokeB(va As Long, b)
    On Error Resume Next
    WriteByte va, CByte(b)
End Sub

Sub PokeL(va As Long, l)
    On Error Resume Next
    WriteLng va, CLng(l)
End Sub

Sub StopDbg()
    
    Set cache.Instructions = New Collection
    
    tm.Clear
    bpm.Clear
    mm.Clear
    sym.Clear
    
    cache.Stack.Cls
    cache.RegBox.Cls
    cache.Display.Cls
    cache.Memory.Cls
    
    Form1.Text1 = "terminated"
    Loaded = False
    StopDebugger
    
End Sub

Sub Run()
    Continue
End Sub

