VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CMatchedCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit
'Copyright 2005
'dzzie@yahoo.com
'http://sandsprite.com

Public Keys As New Collection

'if both key and value are unique per element then
'we can do a bunch of other things with them as a matched
'collection. But we cant always assume we have the luxary
'of unique values, so you configure it at run time. Thefunctions
'that take value as argument will barf with warning if this is
'not set in those cases.
Public ValuesMustBeUnique As Boolean

Function addElement(key, value, Optional Tag) As Boolean
    Dim m As CMatch
    
    If Not KeyExists(key) Then
        If ValuesMustBeUnique Then
             If ValueExists(value) Then Exit Function
        End If
        
        Set m = New CMatch
        m.value = value
        m.Tag = Tag
        m.key = key
        Keys.Add m, "k:" & key
        addElement = True
        
    End If
    
End Function

Function RemoveByKey(key) As Boolean
    If KeyExists(key) Then
        Keys.Remove "k:" & key
        RemoveByKey = True
    End If
End Function

Sub Clear()
    Set Keys = New Collection
End Sub

Function RemoveByValue(value) As Boolean
    Dim k As String
    
    If Not ValuesMustBeUnique Then
        Debug.Print "RemoveByValue: ValuesMustBeUnique not set exiting.."
        Exit Function
    End If
    
    If ValueExists(value) Then
        k = GetKeyByValue(value)
        Keys.Remove "k:" & k
        RemoveByValue = True
    End If
    
End Function

Function GetMatchByKey(key) As CMatch
    If Not KeyExists(key) Then Exit Function
    Set GetMatchByKey = Keys("k:" & key)
End Function

Function GetMatchByValue(value) As CMatch
    
    If Not ValuesMustBeUnique Then
        Debug.Print "GetMatchByValue: ValuesMustBeUnique not set exiting.."
        Exit Function
    End If
    
    If Not ValueExists(value) Then Exit Function
    
    Dim key
    key = GetKeyByValue(value)
    Set GetMatchByValue = Keys("k:" & key)
    
End Function

Function GetTagByKey(key) As Variant
    If Not KeyExists(key) Then Exit Function
    GetTagByKey = Keys("k:" & key).Tag
End Function

Function GetTagByValue(value) As Variant
    On Error Resume Next
    Dim key
    
    If Not ValuesMustBeUnique Then
        Debug.Print "GetTagByValue: ValuesMustBeUnique not set exiting.."
        Exit Function
    End If
    
    key = GetKeyByValue(value)
    GetTagByValue = GetTagByKey(key)
    
End Function

Function GetValueByKey(key)
    If Not KeyExists(key) Then Exit Function
    GetValueByKey = Keys("k:" & key).value
End Function

Function GetKeyByValue(value) 'not guaranteed unique!

    If Not ValueExists(value) Then Exit Function
    
    If Not ValuesMustBeUnique Then
        Debug.Print "GetKeyByValue: ValuesMustBeUnique not set exiting.."
        Exit Function
    End If
    
    Dim m As CMatch
    For Each m In Keys
        If m.value = value Then
            GetKeyByValue = m.key
            Exit Function
        End If
    Next
    
End Function

Function KeyExists(key) As Boolean
    On Error GoTo hell
    Dim x
    If Not Keys("k:" & key) Is Nothing Then KeyExists = True
hell:
End Function

Function ValueExists(value) As Boolean
    On Error GoTo hell
    Dim m As CMatch
    
    If Not ValuesMustBeUnique Then
        Debug.Print "ValueExists: ValuesMustBeUnique not set exiting.."
        Exit Function
    End If
    
    For Each m In Keys
        If m.value = value Then
            ValueExists = True
            Exit Function
        End If
    Next
hell:
End Function


